<template>
  <LineChart
    style="height:250px;"
    :chart-data="dataCollection"
    :options="options"
    :height="null"
    :width="null"
  />
</template>

<script>
import { mapGetters } from 'vuex'
import LineChart from './LineChart'

export default {
  name: 'CustomChart',
  components: {
    LineChart
  },
  props: {
    history: {
      required: true,
      type: Array
    }
  },
  data () {
    return {
      dataCollection: {},
      customData: [],
      options: {
        responsive: true,
        maintainAspectRatio: false,
        aspectRatio: 2,
        title: {
          display: true,
          text: 'Custom chart'
        },
        scales: {
          xAxes: [{
            gridLines: {
              color: '#282828'
            },
            stacked: false
          }],
          yAxes: [{
            gridLines: {
              color: '#282828'
            },
            stacked: false
          }]
        }
      }
    }
  },
  computed: {
    ...mapGetters('player', ['customKey']),
    days () {
      const arr = this.history.map((history) => {
        const date = new Date(history.createdAt)
        const arr = date.toUTCString().split(' ')
        return arr[1] + ' ' + arr[2]
      })
      return arr
    }
  },
  watch: {
    customKey: {
      immediate: true,
      handler (newVal) {
        this.customData = this.history.map((history) => {
          return newVal.split('.').reduce((o, i) => {
            if (o) {
              return o[i]
            }
            return null
          }, history)
        })
        this.dataCollection = {
          labels: this.days,
          datasets: [{
            label: 'Custom metric',
            borderColor: 'green',
            data: this.customData
          }]
        }
      }
    }
  }
}
</script>
